function validateModel( mdlName )
% autosar.api.validateModel Validate the Simulink-AUTOSAR mapping and AUTOSAR
% properties for a model.
% 
% autosar.api.validateModel(MDLNAME) validates the Simulink-AUTOSAR mapping and
% AUTOSAR properties for model MDLNAME.
%
% Examples:
%
% To validate a model
%    autosar.api.validateModel('rtwdemo_autosar_counter');
%
% See also autosar.api.getAUTOSARProperties autosar.api.getSimulinkMapping

%   Copyright 2015 The MathWorks, Inc.

validator = autosar.validation.Validator();
validator.verify(get_param(mdlName, 'Handle'));



% LocalWords:  MDLNAME
