function compList = getComponentNames(this)
%GETCOMPONENTNAMES returns the list of Atomic-Software-Component names and
%    Sensor-Actuator-Component found in the XML files associated with the
%    arxml.importer object.  COMPONENTNAMES = GETCOMPONENTNAMES(IMPORTER) returns
%    the list of component names COMPONENTNAMES found in the XML
%    files associated with the arxml.importer object IMPORTER.
%
%   COMPONENTNAMES is a cell array of strings in which each element is the
%   absolute Short-Name path of the corresponding Atomic-Software-Component and
%   Sensor-Actuator-Component:
%   '/root_package_name[/sub_package_name]/component_short_name'.
%
%   Note:
%      GETCOMPONENTNAMES finds only the Atomic-Software-Component defined in the
%      XML file specified when constructing the arxml.importer object or the
%      XML file specified by the method SETFILE. All Atomic-Software-Components
%      described in the XML file dependencies are ignored. 
%
%   See also arxml.importer.createComponentAsModel 

%   Copyright 2007-2011 The MathWorks, Inc.

compList = [this.getApplicationComponentNames; this.getSensorActuatorComponentNames];

% LocalWords:  COMPONENTNAMES SETFILE
